diff --git a/src/backend/access/heap/rewriteheap.c b/src/backend/access/heap/rewriteheap.c
new file mode 100644
index cca819f..e8102fc
*** a/src/backend/access/heap/rewriteheap.c
--- b/src/backend/access/heap/rewriteheap.c
*************** rewrite_heap_tuple(RewriteState state,
*** 398,403 ****
--- 398,404 ----
  		   &old_tuple->t_data->t_choice.t_heap,
  		   sizeof(HeapTupleFields));
  
+ 	HeapTupleCopyBase(new_tuple, old_tuple);
  	new_tuple->t_data->t_infomask &= ~HEAP_XACT_MASK;
  	new_tuple->t_data->t_infomask2 &= ~HEAP2_XACT_MASK;
  	new_tuple->t_data->t_infomask |=
*************** rewrite_heap_tuple(RewriteState state,
*** 407,413 ****
  	 * While we have our hands on the tuple, we may as well freeze any
  	 * eligible xmin or xmax, so that future VACUUM effort can be saved.
  	 */
! 	heap_freeze_tuple(new_tuple->t_data, state->rs_freeze_xid,
  					  state->rs_cutoff_multi);
  
  	/*
--- 408,414 ----
  	 * While we have our hands on the tuple, we may as well freeze any
  	 * eligible xmin or xmax, so that future VACUUM effort can be saved.
  	 */
! 	heap_freeze_tuple(new_tuple, state->rs_freeze_xid,
  					  state->rs_cutoff_multi);
  
  	/*
*************** rewrite_heap_tuple(RewriteState state,
*** 420,433 ****
  	 * If the tuple has been updated, check the old-to-new mapping hash table.
  	 */
  	if (!((old_tuple->t_data->t_infomask & HEAP_XMAX_INVALID) ||
! 		  HeapTupleHeaderIsOnlyLocked(old_tuple->t_data)) &&
  		!(ItemPointerEquals(&(old_tuple->t_self),
  							&(old_tuple->t_data->t_ctid))))
  	{
  		OldToNewMapping mapping;
  
  		memset(&hashkey, 0, sizeof(hashkey));
! 		hashkey.xmin = HeapTupleHeaderGetUpdateXid(old_tuple->t_data);
  		hashkey.tid = old_tuple->t_data->t_ctid;
  
  		mapping = (OldToNewMapping)
--- 421,434 ----
  	 * If the tuple has been updated, check the old-to-new mapping hash table.
  	 */
  	if (!((old_tuple->t_data->t_infomask & HEAP_XMAX_INVALID) ||
! 		  HeapTupleHeaderIsOnlyLocked(old_tuple)) &&
  		!(ItemPointerEquals(&(old_tuple->t_self),
  							&(old_tuple->t_data->t_ctid))))
  	{
  		OldToNewMapping mapping;
  
  		memset(&hashkey, 0, sizeof(hashkey));
! 		hashkey.xmin = HeapTupleGetUpdateXidAny(old_tuple);
  		hashkey.tid = old_tuple->t_data->t_ctid;
  
  		mapping = (OldToNewMapping)
*************** rewrite_heap_tuple(RewriteState state,
*** 500,506 ****
  		 * RECENTLY_DEAD if and only if the xmin is not before OldestXmin.
  		 */
  		if ((new_tuple->t_data->t_infomask & HEAP_UPDATED) &&
! 			!TransactionIdPrecedes(HeapTupleHeaderGetXmin(new_tuple->t_data),
  								   state->rs_oldest_xmin))
  		{
  			/*
--- 501,507 ----
  		 * RECENTLY_DEAD if and only if the xmin is not before OldestXmin.
  		 */
  		if ((new_tuple->t_data->t_infomask & HEAP_UPDATED) &&
! 			!TransactionIdPrecedes(HeapTupleGetXmin(new_tuple),
  								   state->rs_oldest_xmin))
  		{
  			/*
*************** rewrite_heap_tuple(RewriteState state,
*** 509,515 ****
  			UnresolvedTup unresolved;
  
  			memset(&hashkey, 0, sizeof(hashkey));
! 			hashkey.xmin = HeapTupleHeaderGetXmin(new_tuple->t_data);
  			hashkey.tid = old_tid;
  
  			unresolved = hash_search(state->rs_unresolved_tups, &hashkey,
--- 510,516 ----
  			UnresolvedTup unresolved;
  
  			memset(&hashkey, 0, sizeof(hashkey));
! 			hashkey.xmin = HeapTupleGetXmin(new_tuple);
  			hashkey.tid = old_tid;
  
  			unresolved = hash_search(state->rs_unresolved_tups, &hashkey,
*************** rewrite_heap_dead_tuple(RewriteState sta
*** 597,603 ****
  	bool		found;
  
  	memset(&hashkey, 0, sizeof(hashkey));
! 	hashkey.xmin = HeapTupleHeaderGetXmin(old_tuple->t_data);
  	hashkey.tid = old_tuple->t_self;
  
  	unresolved = hash_search(state->rs_unresolved_tups, &hashkey,
--- 598,604 ----
  	bool		found;
  
  	memset(&hashkey, 0, sizeof(hashkey));
! 	hashkey.xmin = HeapTupleGetXmin(old_tuple);
  	hashkey.tid = old_tuple->t_self;
  
  	unresolved = hash_search(state->rs_unresolved_tups, &hashkey,
*************** raw_heap_insert(RewriteState state, Heap
*** 633,638 ****
--- 634,640 ----
  	Size		len;
  	OffsetNumber newoff;
  	HeapTuple	heaptup;
+ 	TransactionId xmin, xmax;
  
  	/*
  	 * If the new tuple is too big for storage or contains already toasted
*************** raw_heap_insert(RewriteState state, Heap
*** 709,718 ****
--- 711,732 ----
  	{
  		/* Initialize a new empty page */
  		PageInit(page, BLCKSZ, sizeof(HeapPageSpecialData));
+ 		/* FIXME */
  		HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  		state->rs_buffer_valid = true;
  	}
  
+ 	/* FIXME */
+ 	rewrite_page_prepare_for_xid(page, HeapTupleGetXmin(heaptup), false);
+ 	rewrite_page_prepare_for_xid(page, HeapTupleGetRawXmax(heaptup),
+ 		(heaptup->t_data->t_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+ 
+ 	xmin = HeapTupleGetXmin(heaptup);
+ 	xmax = HeapTupleGetRawXmax(heaptup);
+ 	HeapTupleCopyBaseFromPage(heaptup, page);
+ 	HeapTupleSetXmin(heaptup, xmin);
+ 	HeapTupleSetXmax(heaptup, xmax);
+ 
  	/* And now we can insert the tuple into the page */
  	newoff = PageAddItem(page, (Item) heaptup->t_data, heaptup->t_len,
  						 InvalidOffsetNumber, false, true);
*************** logical_rewrite_log_mapping(RewriteState
*** 1007,1013 ****
  				 dboid, relid,
  				 (uint32) (state->rs_begin_lsn >> 32),
  				 (uint32) state->rs_begin_lsn,
! 				 xid, GetCurrentTransactionId());
  
  		dlist_init(&src->mappings);
  		src->num_mappings = 0;
--- 1021,1030 ----
  				 dboid, relid,
  				 (uint32) (state->rs_begin_lsn >> 32),
  				 (uint32) state->rs_begin_lsn,
! 				 (uint32) (xid >> 32),
! 				 (uint32) xid,
! 				 (uint32) (GetCurrentTransactionId() >> 32),
! 				 (uint32) GetCurrentTransactionId());
  
  		dlist_init(&src->mappings);
  		src->num_mappings = 0;
*************** logical_rewrite_heap_tuple(RewriteState 
*** 1057,1065 ****
  	if (!state->rs_logical_rewrite)
  		return;
  
! 	xmin = HeapTupleHeaderGetXmin(new_tuple->t_data);
  	/* use *GetUpdateXid to correctly deal with multixacts */
! 	xmax = HeapTupleHeaderGetUpdateXid(new_tuple->t_data);
  
  	/*
  	 * Log the mapping iff the tuple has been created recently.
--- 1074,1082 ----
  	if (!state->rs_logical_rewrite)
  		return;
  
! 	xmin = HeapTupleGetXmin(new_tuple);
  	/* use *GetUpdateXid to correctly deal with multixacts */
! 	xmax = HeapTupleGetUpdateXidAny(new_tuple);
  
  	/*
  	 * Log the mapping iff the tuple has been created recently.
*************** heap_xlog_logical_rewrite(XLogReaderStat
*** 1131,1137 ****
  			 xlrec->mapped_db, xlrec->mapped_rel,
  			 (uint32) (xlrec->start_lsn >> 32),
  			 (uint32) xlrec->start_lsn,
! 			 xlrec->mapped_xid, XLogRecGetXid(r));
  
  	fd = OpenTransientFile(path,
  						   O_CREAT | O_WRONLY | PG_BINARY,
--- 1148,1157 ----
  			 xlrec->mapped_db, xlrec->mapped_rel,
  			 (uint32) (xlrec->start_lsn >> 32),
  			 (uint32) xlrec->start_lsn,
! 			 (uint32) (xlrec->mapped_xid >> 32),
! 			 (uint32) xlrec->mapped_xid,
! 			 (uint32) (XLogRecGetXid(r) >> 32),
! 			 (uint32) XLogRecGetXid(r));
  
  	fd = OpenTransientFile(path,
  						   O_CREAT | O_WRONLY | PG_BINARY,
*************** CheckPointLogicalRewriteHeap(void)
*** 1226,1235 ****
  		Oid			dboid;
  		Oid			relid;
  		XLogRecPtr	lsn;
! 		TransactionId rewrite_xid;
! 		TransactionId create_xid;
! 		uint32		hi,
! 					lo;
  
  		if (strcmp(mapping_de->d_name, ".") == 0 ||
  			strcmp(mapping_de->d_name, "..") == 0)
--- 1246,1257 ----
  		Oid			dboid;
  		Oid			relid;
  		XLogRecPtr	lsn;
! 		uint32		lsn_hi,
! 					lsn_lo,
! 					rewrite_xid_hi,
! 					rewrite_xid_lo,
! 					create_xid_hi,
! 					create_xid_lo;
  
  		if (strcmp(mapping_de->d_name, ".") == 0 ||
  			strcmp(mapping_de->d_name, "..") == 0)
*************** CheckPointLogicalRewriteHeap(void)
*** 1244,1253 ****
  			continue;
  
  		if (sscanf(mapping_de->d_name, LOGICAL_REWRITE_FORMAT,
! 				   &dboid, &relid, &hi, &lo, &rewrite_xid, &create_xid) != 6)
  			elog(ERROR, "could not parse filename \"%s\"", mapping_de->d_name);
  
! 		lsn = ((uint64) hi) << 32 | lo;
  
  		if (lsn < cutoff || cutoff == InvalidXLogRecPtr)
  		{
--- 1266,1277 ----
  			continue;
  
  		if (sscanf(mapping_de->d_name, LOGICAL_REWRITE_FORMAT,
! 				   &dboid, &relid, &lsn_hi, &lsn_lo,
! 				   &rewrite_xid_hi, &rewrite_xid_lo,
! 				   &create_xid_hi, &create_xid_lo) != 8)
  			elog(ERROR, "could not parse filename \"%s\"", mapping_de->d_name);
  
! 		lsn = ((uint64) lsn_hi) << 32 | lsn_lo;
  
  		if (lsn < cutoff || cutoff == InvalidXLogRecPtr)
  		{
diff --git a/src/backend/access/heap/tuptoaster.c b/src/backend/access/heap/tuptoaster.c
new file mode 100644
index aa5a45d..6d917b6
*** a/src/backend/access/heap/tuptoaster.c
--- b/src/backend/access/heap/tuptoaster.c
*************** toast_insert_or_update(Relation rel, Hea
*** 1026,1031 ****
--- 1026,1032 ----
  		result_tuple->t_len = new_tuple_len;
  		result_tuple->t_self = newtup->t_self;
  		result_tuple->t_tableOid = newtup->t_tableOid;
+ 		HeapTupleCopyBase(result_tuple, newtup);
  		new_data = (HeapTupleHeader) ((char *) result_tuple + HEAPTUPLESIZE);
  		result_tuple->t_data = new_data;
  
*************** toast_flatten_tuple(HeapTuple tup, Tuple
*** 1133,1138 ****
--- 1134,1140 ----
  
  	new_tuple->t_self = tup->t_self;
  	new_tuple->t_tableOid = tup->t_tableOid;
+ 	HeapTupleCopyBase(new_tuple, tup);
  
  	new_tuple->t_data->t_choice = tup->t_data->t_choice;
  	new_tuple->t_data->t_ctid = tup->t_data->t_ctid;
*************** toast_flatten_tuple_to_datum(HeapTupleHe
*** 1206,1211 ****
--- 1208,1214 ----
  	ItemPointerSetInvalid(&(tmptup.t_self));
  	tmptup.t_tableOid = InvalidOid;
  	tmptup.t_data = tup;
+ 	HeapTupleSetZeroBase(&tmptup);
  
  	/*
  	 * Break down the tuple into fields.
diff --git a/src/backend/access/nbtree/nbtxlog.c b/src/backend/access/nbtree/nbtxlog.c
new file mode 100644
index ac60db0..d41f1d8
*** a/src/backend/access/nbtree/nbtxlog.c
--- b/src/backend/access/nbtree/nbtxlog.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/bufmask.h"
  #include "access/heapam_xlog.h"
+ #include "access/htup_details.h"
  #include "access/nbtree.h"
  #include "access/nbtxlog.h"
  #include "access/transam.h"
*************** btree_xlog_delete_get_latestRemovedXid(X
*** 628,636 ****
  		 */
  		if (ItemIdHasStorage(hitemid))
  		{
  			htuphdr = (HeapTupleHeader) PageGetItem(hpage, hitemid);
  
! 			HeapTupleHeaderAdvanceLatestRemovedXid(htuphdr, &latestRemovedXid);
  		}
  		else if (ItemIdIsDead(hitemid))
  		{
--- 629,641 ----
  		 */
  		if (ItemIdHasStorage(hitemid))
  		{
+ 			HeapTupleData htup;
+ 
  			htuphdr = (HeapTupleHeader) PageGetItem(hpage, hitemid);
+ 			htup.t_data = htuphdr;
+ 			HeapTupleCopyBaseFromPage(&htup, hpage);
  
! 			HeapTupleHeaderAdvanceLatestRemovedXid(&htup, &latestRemovedXid);
  		}
  		else if (ItemIdIsDead(hitemid))
  		{
diff --git a/src/backend/access/rmgrdesc/clogdesc.c b/src/backend/access/rmgrdesc/clogdesc.c
new file mode 100644
index 9181154..844c83d
*** a/src/backend/access/rmgrdesc/clogdesc.c
--- b/src/backend/access/rmgrdesc/clogdesc.c
*************** clog_desc(StringInfo buf, XLogReaderStat
*** 25,41 ****
  
  	if (info == CLOG_ZEROPAGE)
  	{
! 		int			pageno;
  
! 		memcpy(&pageno, rec, sizeof(int));
! 		appendStringInfo(buf, "page %d", pageno);
  	}
  	else if (info == CLOG_TRUNCATE)
  	{
  		xl_clog_truncate xlrec;
  
  		memcpy(&xlrec, rec, sizeof(xl_clog_truncate));
! 		appendStringInfo(buf, "page %d; oldestXact %u",
  						 xlrec.pageno, xlrec.oldestXact);
  	}
  }
--- 25,41 ----
  
  	if (info == CLOG_ZEROPAGE)
  	{
! 		int64		pageno;
  
! 		memcpy(&pageno, rec, sizeof(int64));
! 		appendStringInfo(buf, "page " INT64_FORMAT, pageno);
  	}
  	else if (info == CLOG_TRUNCATE)
  	{
  		xl_clog_truncate xlrec;
  
  		memcpy(&xlrec, rec, sizeof(xl_clog_truncate));
! 		appendStringInfo(buf, "page " INT64_FORMAT "; oldestXact " XID_FMT,
  						 xlrec.pageno, xlrec.oldestXact);
  	}
  }
diff --git a/src/backend/access/rmgrdesc/committsdesc.c b/src/backend/access/rmgrdesc/committsdesc.c
new file mode 100644
index 3e670bd..be6e167
*** a/src/backend/access/rmgrdesc/committsdesc.c
--- b/src/backend/access/rmgrdesc/committsdesc.c
*************** commit_ts_desc(StringInfo buf, XLogReade
*** 26,41 ****
  
  	if (info == COMMIT_TS_ZEROPAGE)
  	{
! 		int			pageno;
  
! 		memcpy(&pageno, rec, sizeof(int));
! 		appendStringInfo(buf, "%d", pageno);
  	}
  	else if (info == COMMIT_TS_TRUNCATE)
  	{
  		xl_commit_ts_truncate *trunc = (xl_commit_ts_truncate *) rec;
  
! 		appendStringInfo(buf, "pageno %d, oldestXid %u",
  						 trunc->pageno, trunc->oldestXid);
  	}
  	else if (info == COMMIT_TS_SETTS)
--- 26,41 ----
  
  	if (info == COMMIT_TS_ZEROPAGE)
  	{
! 		int64		pageno;
  
! 		memcpy(&pageno, rec, sizeof(int64));
! 		appendStringInfo(buf, INT64_FORMAT, pageno);
  	}
  	else if (info == COMMIT_TS_TRUNCATE)
  	{
  		xl_commit_ts_truncate *trunc = (xl_commit_ts_truncate *) rec;
  
! 		appendStringInfo(buf, "pageno " INT64_FORMAT ", oldestXid " XID_FMT,
  						 trunc->pageno, trunc->oldestXid);
  	}
  	else if (info == COMMIT_TS_SETTS)
*************** commit_ts_desc(StringInfo buf, XLogReade
*** 43,49 ****
  		xl_commit_ts_set *xlrec = (xl_commit_ts_set *) rec;
  		int			nsubxids;
  
! 		appendStringInfo(buf, "set %s/%d for: %u",
  						 timestamptz_to_str(xlrec->timestamp),
  						 xlrec->nodeid,
  						 xlrec->mainxid);
--- 43,49 ----
  		xl_commit_ts_set *xlrec = (xl_commit_ts_set *) rec;
  		int			nsubxids;
  
! 		appendStringInfo(buf, "set %s/%d for: " XID_FMT,
  						 timestamptz_to_str(xlrec->timestamp),
  						 xlrec->nodeid,
  						 xlrec->mainxid);
*************** commit_ts_desc(StringInfo buf, XLogReade
*** 59,65 ****
  				   XLogRecGetData(record) + SizeOfCommitTsSet,
  				   sizeof(TransactionId) * nsubxids);
  			for (i = 0; i < nsubxids; i++)
! 				appendStringInfo(buf, ", %u", subxids[i]);
  			pfree(subxids);
  		}
  	}
--- 59,65 ----
  				   XLogRecGetData(record) + SizeOfCommitTsSet,
  				   sizeof(TransactionId) * nsubxids);
  			for (i = 0; i < nsubxids; i++)
! 				appendStringInfo(buf, ", " XID_FMT, subxids[i]);
  			pfree(subxids);
  		}
  	}
diff --git a/src/backend/access/rmgrdesc/heapdesc.c b/src/backend/access/rmgrdesc/heapdesc.c
new file mode 100644
index 44d2d63..33cd527
*** a/src/backend/access/rmgrdesc/heapdesc.c
--- b/src/backend/access/rmgrdesc/heapdesc.c
*************** heap_desc(StringInfo buf, XLogReaderStat
*** 55,77 ****
  	{
  		xl_heap_update *xlrec = (xl_heap_update *) rec;
  
! 		appendStringInfo(buf, "off %u xmax %u ",
  						 xlrec->old_offnum,
  						 xlrec->old_xmax);
  		out_infobits(buf, xlrec->old_infobits_set);
! 		appendStringInfo(buf, "; new off %u xmax %u",
  						 xlrec->new_offnum,
  						 xlrec->new_xmax);
  	}
  	else if (info == XLOG_HEAP_HOT_UPDATE)
  	{
  		xl_heap_update *xlrec = (xl_heap_update *) rec;
  
! 		appendStringInfo(buf, "off %u xmax %u ",
  						 xlrec->old_offnum,
  						 xlrec->old_xmax);
  		out_infobits(buf, xlrec->old_infobits_set);
! 		appendStringInfo(buf, "; new off %u xmax %u",
  						 xlrec->new_offnum,
  						 xlrec->new_xmax);
  	}
--- 55,85 ----
  	{
  		xl_heap_update *xlrec = (xl_heap_update *) rec;
  
! 		appendStringInfo(buf, "off %u xmax " XID_FMT " ",
  						 xlrec->old_offnum,
  						 xlrec->old_xmax);
  		out_infobits(buf, xlrec->old_infobits_set);
! 		appendStringInfo(buf, "; new off %u xmax " XID_FMT,
  						 xlrec->new_offnum,
  						 xlrec->new_xmax);
  	}
+ 	else if (info == XLOG_HEAP_BASE_SHIFT)
+ 	{
+ 		xl_heap_base_shift *xlrec = (xl_heap_base_shift *) rec;
+ 
+ 		appendStringInfo(buf, "%s delta " INT64_FORMAT " ",
+ 						 xlrec->multi ? "MultiXactId" : "XactId",
+ 						 xlrec->delta);
+ 	}
  	else if (info == XLOG_HEAP_HOT_UPDATE)
  	{
  		xl_heap_update *xlrec = (xl_heap_update *) rec;
  
! 		appendStringInfo(buf, "off %u xmax " XID_FMT " ",
  						 xlrec->old_offnum,
  						 xlrec->old_xmax);
  		out_infobits(buf, xlrec->old_infobits_set);
! 		appendStringInfo(buf, "; new off %u xmax " XID_FMT,
  						 xlrec->new_offnum,
  						 xlrec->new_xmax);
  	}
*************** heap_desc(StringInfo buf, XLogReaderStat
*** 85,91 ****
  	{
  		xl_heap_lock *xlrec = (xl_heap_lock *) rec;
  
! 		appendStringInfo(buf, "off %u: xid %u: flags %u ",
  						 xlrec->offnum, xlrec->locking_xid, xlrec->flags);
  		out_infobits(buf, xlrec->infobits_set);
  	}
--- 93,99 ----
  	{
  		xl_heap_lock *xlrec = (xl_heap_lock *) rec;
  
! 		appendStringInfo(buf, "off %u: xid " XID_FMT ": flags %u ",
  						 xlrec->offnum, xlrec->locking_xid, xlrec->flags);
  		out_infobits(buf, xlrec->infobits_set);
  	}
*************** heap2_desc(StringInfo buf, XLogReaderSta
*** 107,132 ****
  	{
  		xl_heap_clean *xlrec = (xl_heap_clean *) rec;
  
! 		appendStringInfo(buf, "remxid %u", xlrec->latestRemovedXid);
  	}
  	else if (info == XLOG_HEAP2_FREEZE_PAGE)
  	{
  		xl_heap_freeze_page *xlrec = (xl_heap_freeze_page *) rec;
  
! 		appendStringInfo(buf, "cutoff xid %u ntuples %u",
  						 xlrec->cutoff_xid, xlrec->ntuples);
  	}
  	else if (info == XLOG_HEAP2_CLEANUP_INFO)
  	{
  		xl_heap_cleanup_info *xlrec = (xl_heap_cleanup_info *) rec;
  
! 		appendStringInfo(buf, "remxid %u", xlrec->latestRemovedXid);
  	}
  	else if (info == XLOG_HEAP2_VISIBLE)
  	{
  		xl_heap_visible *xlrec = (xl_heap_visible *) rec;
  
! 		appendStringInfo(buf, "cutoff xid %u flags %d",
  						 xlrec->cutoff_xid, xlrec->flags);
  	}
  	else if (info == XLOG_HEAP2_MULTI_INSERT)
--- 115,140 ----
  	{
  		xl_heap_clean *xlrec = (xl_heap_clean *) rec;
  
! 		appendStringInfo(buf, "remxid " XID_FMT, xlrec->latestRemovedXid);
  	}
  	else if (info == XLOG_HEAP2_FREEZE_PAGE)
  	{
  		xl_heap_freeze_page *xlrec = (xl_heap_freeze_page *) rec;
  
! 		appendStringInfo(buf, "cutoff xid " XID_FMT " ntuples %u",
  						 xlrec->cutoff_xid, xlrec->ntuples);
  	}
  	else if (info == XLOG_HEAP2_CLEANUP_INFO)
  	{
  		xl_heap_cleanup_info *xlrec = (xl_heap_cleanup_info *) rec;
  
! 		appendStringInfo(buf, "remxid " XID_FMT, xlrec->latestRemovedXid);
  	}
  	else if (info == XLOG_HEAP2_VISIBLE)
  	{
  		xl_heap_visible *xlrec = (xl_heap_visible *) rec;
  
! 		appendStringInfo(buf, "cutoff xid " XID_FMT " flags %d",
  						 xlrec->cutoff_xid, xlrec->flags);
  	}
  	else if (info == XLOG_HEAP2_MULTI_INSERT)
*************** heap2_desc(StringInfo buf, XLogReaderSta
*** 139,145 ****
  	{
  		xl_heap_lock_updated *xlrec = (xl_heap_lock_updated *) rec;
  
! 		appendStringInfo(buf, "off %u: xmax %u: flags %u ",
  						 xlrec->offnum, xlrec->xmax, xlrec->flags);
  		out_infobits(buf, xlrec->infobits_set);
  	}
--- 147,153 ----
  	{
  		xl_heap_lock_updated *xlrec = (xl_heap_lock_updated *) rec;
  
! 		appendStringInfo(buf, "off %u: xmax " XID_FMT ": flags %u ",
  						 xlrec->offnum, xlrec->xmax, xlrec->flags);
  		out_infobits(buf, xlrec->infobits_set);
  	}
*************** heap_identify(uint8 info)
*** 180,185 ****
--- 188,196 ----
  		case XLOG_HEAP_UPDATE | XLOG_HEAP_INIT_PAGE:
  			id = "UPDATE+INIT";
  			break;
+ 		case XLOG_HEAP_BASE_SHIFT:
+ 			id = "BASE_SHIFT";
+ 			break;
  		case XLOG_HEAP_HOT_UPDATE:
  			id = "HOT_UPDATE";
  			break;
diff --git a/src/backend/access/rmgrdesc/mxactdesc.c b/src/backend/access/rmgrdesc/mxactdesc.c
new file mode 100644
index 9c17447..0c78b76
*** a/src/backend/access/rmgrdesc/mxactdesc.c
--- b/src/backend/access/rmgrdesc/mxactdesc.c
***************
*** 19,25 ****
  static void
  out_member(StringInfo buf, MultiXactMember *member)
  {
! 	appendStringInfo(buf, "%u ", member->xid);
  	switch (member->status)
  	{
  		case MultiXactStatusForKeyShare:
--- 19,25 ----
  static void
  out_member(StringInfo buf, MultiXactMember *member)
  {
! 	appendStringInfo(buf, XID_FMT " ", member->xid);
  	switch (member->status)
  	{
  		case MultiXactStatusForKeyShare:
*************** multixact_desc(StringInfo buf, XLogReade
*** 55,72 ****
  	if (info == XLOG_MULTIXACT_ZERO_OFF_PAGE ||
  		info == XLOG_MULTIXACT_ZERO_MEM_PAGE)
  	{
! 		int			pageno;
  
  		memcpy(&pageno, rec, sizeof(int));
! 		appendStringInfo(buf, "%d", pageno);
  	}
  	else if (info == XLOG_MULTIXACT_CREATE_ID)
  	{
  		xl_multixact_create *xlrec = (xl_multixact_create *) rec;
  		int			i;
  
! 		appendStringInfo(buf, "%u offset %u nmembers %d: ", xlrec->mid,
! 						 xlrec->moff, xlrec->nmembers);
  		for (i = 0; i < xlrec->nmembers; i++)
  			out_member(buf, &xlrec->members[i]);
  	}
--- 55,72 ----
  	if (info == XLOG_MULTIXACT_ZERO_OFF_PAGE ||
  		info == XLOG_MULTIXACT_ZERO_MEM_PAGE)
  	{
! 		int64		pageno;
  
  		memcpy(&pageno, rec, sizeof(int));
! 		appendStringInfo(buf, INT64_FORMAT, pageno);
  	}
  	else if (info == XLOG_MULTIXACT_CREATE_ID)
  	{
  		xl_multixact_create *xlrec = (xl_multixact_create *) rec;
  		int			i;
  
! 		appendStringInfo(buf, XID_FMT " offset " INT64_FORMAT " nmembers %d: ",
! 						 xlrec->mid, xlrec->moff, xlrec->nmembers);
  		for (i = 0; i < xlrec->nmembers; i++)
  			out_member(buf, &xlrec->members[i]);
  	}
*************** multixact_desc(StringInfo buf, XLogReade
*** 74,80 ****
  	{
  		xl_multixact_truncate *xlrec = (xl_multixact_truncate *) rec;
  
! 		appendStringInfo(buf, "offsets [%u, %u), members [%u, %u)",
  						 xlrec->startTruncOff, xlrec->endTruncOff,
  						 xlrec->startTruncMemb, xlrec->endTruncMemb);
  	}
--- 74,80 ----
  	{
  		xl_multixact_truncate *xlrec = (xl_multixact_truncate *) rec;
  
! 		appendStringInfo(buf, "offsets [" XID_FMT ", " XID_FMT "), members [" INT64_FORMAT ", " INT64_FORMAT ")",
  						 xlrec->startTruncOff, xlrec->endTruncOff,
  						 xlrec->startTruncMemb, xlrec->endTruncMemb);
  	}
diff --git a/src/backend/access/rmgrdesc/nbtdesc.c b/src/backend/access/rmgrdesc/nbtdesc.c
new file mode 100644
index fbde9d6..e64816d
*** a/src/backend/access/rmgrdesc/nbtdesc.c
--- b/src/backend/access/rmgrdesc/nbtdesc.c
*************** btree_desc(StringInfo buf, XLogReaderSta
*** 72,78 ****
  			{
  				xl_btree_unlink_page *xlrec = (xl_btree_unlink_page *) rec;
  
! 				appendStringInfo(buf, "left %u; right %u; btpo_xact %u; ",
  								 xlrec->leftsib, xlrec->rightsib,
  								 xlrec->btpo_xact);
  				appendStringInfo(buf, "leafleft %u; leafright %u; topparent %u",
--- 72,78 ----
  			{
  				xl_btree_unlink_page *xlrec = (xl_btree_unlink_page *) rec;
  
! 				appendStringInfo(buf, "left %u; right %u; btpo_xact " XID_FMT "; ",
  								 xlrec->leftsib, xlrec->rightsib,
  								 xlrec->btpo_xact);
  				appendStringInfo(buf, "leafleft %u; leafright %u; topparent %u",
*************** btree_desc(StringInfo buf, XLogReaderSta
*** 91,97 ****
  			{
  				xl_btree_reuse_page *xlrec = (xl_btree_reuse_page *) rec;
  
! 				appendStringInfo(buf, "rel %u/%u/%u; latestRemovedXid %u",
  								 xlrec->node.spcNode, xlrec->node.dbNode,
  							   xlrec->node.relNode, xlrec->latestRemovedXid);
  				break;
--- 91,97 ----
  			{
  				xl_btree_reuse_page *xlrec = (xl_btree_reuse_page *) rec;
  
! 				appendStringInfo(buf, "rel %u/%u/%u; latestRemovedXid " XID_FMT,
  								 xlrec->node.spcNode, xlrec->node.dbNode,
  							   xlrec->node.relNode, xlrec->latestRemovedXid);
  				break;
diff --git a/src/backend/access/rmgrdesc/spgdesc.c b/src/backend/access/rmgrdesc/spgdesc.c
new file mode 100644
index 24d6cb5..fbae918
*** a/src/backend/access/rmgrdesc/spgdesc.c
--- b/src/backend/access/rmgrdesc/spgdesc.c
*************** spg_desc(StringInfo buf, XLogReaderState
*** 75,81 ****
  			/* no further information */
  			break;
  		case XLOG_SPGIST_VACUUM_REDIRECT:
! 			appendStringInfo(buf, "newest XID %u",
  						 ((spgxlogVacuumRedirect *) rec)->newestRedirectXid);
  			break;
  	}
--- 75,81 ----
  			/* no further information */
  			break;
  		case XLOG_SPGIST_VACUUM_REDIRECT:
! 			appendStringInfo(buf, "newest XID " XID_FMT,
  						 ((spgxlogVacuumRedirect *) rec)->newestRedirectXid);
  			break;
  	}
diff --git a/src/backend/access/rmgrdesc/standbydesc.c b/src/backend/access/rmgrdesc/standbydesc.c
new file mode 100644
index 278546a..38222ed
*** a/src/backend/access/rmgrdesc/standbydesc.c
--- b/src/backend/access/rmgrdesc/standbydesc.c
*************** standby_desc_running_xacts(StringInfo bu
*** 21,27 ****
  {
  	int			i;
  
! 	appendStringInfo(buf, "nextXid %u latestCompletedXid %u oldestRunningXid %u",
  					 xlrec->nextXid,
  					 xlrec->latestCompletedXid,
  					 xlrec->oldestRunningXid);
--- 21,27 ----
  {
  	int			i;
  
! 	appendStringInfo(buf, "nextXid " XID_FMT " latestCompletedXid " XID_FMT " oldestRunningXid " XID_FMT,
  					 xlrec->nextXid,
  					 xlrec->latestCompletedXid,
  					 xlrec->oldestRunningXid);
*************** standby_desc_running_xacts(StringInfo bu
*** 29,35 ****
  	{
  		appendStringInfo(buf, "; %d xacts:", xlrec->xcnt);
  		for (i = 0; i < xlrec->xcnt; i++)
! 			appendStringInfo(buf, " %u", xlrec->xids[i]);
  	}
  
  	if (xlrec->subxid_overflow)
--- 29,35 ----
  	{
  		appendStringInfo(buf, "; %d xacts:", xlrec->xcnt);
  		for (i = 0; i < xlrec->xcnt; i++)
! 			appendStringInfo(buf, " " XID_FMT, xlrec->xids[i]);
  	}
  
  	if (xlrec->subxid_overflow)
*************** standby_desc(StringInfo buf, XLogReaderS
*** 48,54 ****
  		int			i;
  
  		for (i = 0; i < xlrec->nlocks; i++)
! 			appendStringInfo(buf, "xid %u db %u rel %u ",
  							 xlrec->locks[i].xid, xlrec->locks[i].dbOid,
  							 xlrec->locks[i].relOid);
  	}
--- 48,54 ----
  		int			i;
  
  		for (i = 0; i < xlrec->nlocks; i++)
! 			appendStringInfo(buf, "xid " XID_FMT " db %u rel %u ",
  							 xlrec->locks[i].xid, xlrec->locks[i].dbOid,
  							 xlrec->locks[i].relOid);
  	}
diff --git a/src/backend/access/rmgrdesc/xactdesc.c b/src/backend/access/rmgrdesc/xactdesc.c
new file mode 100644
index 735f8c5..73446ad
*** a/src/backend/access/rmgrdesc/xactdesc.c
--- b/src/backend/access/rmgrdesc/xactdesc.c
*************** ParseCommitRecord(uint8 info, xl_xact_co
*** 73,78 ****
--- 73,87 ----
  		data += parsed->nsubxacts * sizeof(TransactionId);
  	}
  
+ 	if (parsed->xinfo & XACT_XINFO_HAS_TWOPHASE)
+ 	{
+ 		xl_xact_twophase *xl_twophase = (xl_xact_twophase *) data;
+ 
+ 		parsed->twophase_xid = xl_twophase->xid;
+ 
+ 		data += sizeof(xl_xact_twophase);
+ 	}
+ 
  	if (parsed->xinfo & XACT_XINFO_HAS_RELFILENODES)
  	{
  		xl_xact_relfilenodes *xl_relfilenodes = (xl_xact_relfilenodes *) data;
*************** ParseCommitRecord(uint8 info, xl_xact_co
*** 95,109 ****
  		data += xl_invals->nmsgs * sizeof(SharedInvalidationMessage);
  	}
  
- 	if (parsed->xinfo & XACT_XINFO_HAS_TWOPHASE)
- 	{
- 		xl_xact_twophase *xl_twophase = (xl_xact_twophase *) data;
- 
- 		parsed->twophase_xid = xl_twophase->xid;
- 
- 		data += sizeof(xl_xact_twophase);
- 	}
- 
  	if (parsed->xinfo & XACT_XINFO_HAS_ORIGIN)
  	{
  		xl_xact_origin xl_origin;
--- 104,109 ----
*************** ParseAbortRecord(uint8 info, xl_xact_abo
*** 150,155 ****
--- 150,164 ----
  		data += parsed->nsubxacts * sizeof(TransactionId);
  	}
  
+ 	if (parsed->xinfo & XACT_XINFO_HAS_TWOPHASE)
+ 	{
+ 		xl_xact_twophase *xl_twophase = (xl_xact_twophase *) data;
+ 
+ 		parsed->twophase_xid = xl_twophase->xid;
+ 
+ 		data += sizeof(xl_xact_twophase);
+ 	}
+ 
  	if (parsed->xinfo & XACT_XINFO_HAS_RELFILENODES)
  	{
  		xl_xact_relfilenodes *xl_relfilenodes = (xl_xact_relfilenodes *) data;
*************** ParseAbortRecord(uint8 info, xl_xact_abo
*** 160,174 ****
  		data += MinSizeOfXactRelfilenodes;
  		data += xl_relfilenodes->nrels * sizeof(RelFileNode);
  	}
- 
- 	if (parsed->xinfo & XACT_XINFO_HAS_TWOPHASE)
- 	{
- 		xl_xact_twophase *xl_twophase = (xl_xact_twophase *) data;
- 
- 		parsed->twophase_xid = xl_twophase->xid;
- 
- 		data += sizeof(xl_xact_twophase);
- 	}
  }
  
  static void
--- 169,174 ----
*************** xact_desc_commit(StringInfo buf, uint8 i
*** 181,187 ****
  
  	/* If this is a prepared xact, show the xid of the original xact */
  	if (TransactionIdIsValid(parsed.twophase_xid))
! 		appendStringInfo(buf, "%u: ", parsed.twophase_xid);
  
  	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
  
--- 181,187 ----
  
  	/* If this is a prepared xact, show the xid of the original xact */
  	if (TransactionIdIsValid(parsed.twophase_xid))
! 		appendStringInfo(buf, XID_FMT ": ", parsed.twophase_xid);
  
  	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
  
*************** xact_desc_commit(StringInfo buf, uint8 i
*** 200,206 ****
  	{
  		appendStringInfoString(buf, "; subxacts:");
  		for (i = 0; i < parsed.nsubxacts; i++)
! 			appendStringInfo(buf, " %u", parsed.subxacts[i]);
  	}
  	if (parsed.nmsgs > 0)
  	{
--- 200,206 ----
  	{
  		appendStringInfoString(buf, "; subxacts:");
  		for (i = 0; i < parsed.nsubxacts; i++)
! 			appendStringInfo(buf, " " XID_FMT, parsed.subxacts[i]);
  	}
  	if (parsed.nmsgs > 0)
  	{
*************** xact_desc_abort(StringInfo buf, uint8 in
*** 232,238 ****
  
  	/* If this is a prepared xact, show the xid of the original xact */
  	if (TransactionIdIsValid(parsed.twophase_xid))
! 		appendStringInfo(buf, "%u: ", parsed.twophase_xid);
  
  	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
  	if (parsed.nrels > 0)
--- 232,238 ----
  
  	/* If this is a prepared xact, show the xid of the original xact */
  	if (TransactionIdIsValid(parsed.twophase_xid))
! 		appendStringInfo(buf, XID_FMT ": ", parsed.twophase_xid);
  
  	appendStringInfoString(buf, timestamptz_to_str(xlrec->xact_time));
  	if (parsed.nrels > 0)
*************** xact_desc_abort(StringInfo buf, uint8 in
*** 251,257 ****
  	{
  		appendStringInfoString(buf, "; subxacts:");
  		for (i = 0; i < parsed.nsubxacts; i++)
! 			appendStringInfo(buf, " %u", parsed.subxacts[i]);
  	}
  }
  
--- 251,257 ----
  	{
  		appendStringInfoString(buf, "; subxacts:");
  		for (i = 0; i < parsed.nsubxacts; i++)
! 			appendStringInfo(buf, " " XID_FMT, parsed.subxacts[i]);
  	}
  }
  
*************** xact_desc_assignment(StringInfo buf, xl_
*** 263,269 ****
  	appendStringInfoString(buf, "subxacts:");
  
  	for (i = 0; i < xlrec->nsubxacts; i++)
! 		appendStringInfo(buf, " %u", xlrec->xsub[i]);
  }
  
  void
--- 263,269 ----
  	appendStringInfoString(buf, "subxacts:");
  
  	for (i = 0; i < xlrec->nsubxacts; i++)
! 		appendStringInfo(buf, " " XID_FMT, xlrec->xsub[i]);
  }
  
  void
*************** xact_desc(StringInfo buf, XLogReaderStat
*** 294,300 ****
  		 * interested in the top-level xid that issued the record and which
  		 * xids are being reported here.
  		 */
! 		appendStringInfo(buf, "xtop %u: ", xlrec->xtop);
  		xact_desc_assignment(buf, xlrec);
  	}
  }
--- 294,300 ----
  		 * interested in the top-level xid that issued the record and which
  		 * xids are being reported here.
  		 */
! 		appendStringInfo(buf, "xtop " XID_FMT ": ", xlrec->xtop);
  		xact_desc_assignment(buf, xlrec);
  	}
  }
